#include <stdio.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <termios.h>
#include <unistd.h>
#include <dirent.h>
#define  PERMS 0666

void	fatal(char *);

main(int argc, char *argv[])
{
	void	copy_directory(DIR *, char *, char *);
	DIR	*dir;
	char	source[BUFSIZ], object[BUFSIZ];
	struct	stat	source_stat, object_stat;

	if(argc < 3)
		{
		puts(" : a.out source directory");
		puts(" : a.out source1 source2 ... directory");
		exit(0);
		}


	if(stat(argv[argc - 1], &source_stat) < 0)
		fatal("source stat");
	if(!S_ISDIR(source_stat.st_mode & S_IFMT))
		{
		puts("object is not directory");
		exit(0);
		}
	strcpy(object, argv[argc - 1]);

	if(stat(*++argv, &source_stat) < 0)
		fatal("source stat");
	if(S_ISDIR(source_stat.st_mode & S_IFMT))
		strcpy(source, *argv);
	else	strcpy(source, ".");

		
	if((dir = opendir(source)) == NULL)
		fatal("opendir");

	copy_directory(dir, source, object);

}

void
copy_directory(DIR *dir, char *source, char *object)
{
	struct	dirent	*directory;
	char	source_buff[BUFSIZ];
	char	object_buff[BUFSIZ];
	char	buff[BUFSIZ];
	char	object_directory[BUFSIZ];
	struct	stat	source_stat;
	int	read_number;
	int	source_fd, object_fd;

	while(directory = readdir(dir))
		{
		if(!strncmp(directory->d_name, ".", 1))
			continue;

		if(directory->d_ino == 0)
			continue;

		sprintf(source_buff, "%s/%s", source, directory->d_name);
		if(stat(source_buff, &source_stat) < 0)
			fatal("stat");

		if(S_ISDIR(source_stat.st_mode & S_IFMT))
			{
			DIR	*imsi_dir;

			if(!strcmp((char *)(strchr(source_buff, '/') + 1), object))
				continue;
				
			sprintf(object_directory, 
				"%s/%s", object, strchr(source_buff, '/')+1);

			mkdir(object_directory, 0766);
			imsi_dir = opendir(source_buff);
			copy_directory(imsi_dir, source_buff, object);
			}

		sprintf(object_buff, "%s%s", object, strchr(source_buff, '/'));
		if((source_fd = open(source_buff, O_RDONLY)) < 0)
			fatal("source open");
		if((object_fd = 
			open(object_buff, O_WRONLY | O_CREAT | O_TRUNC, PERMS)) < 0)
			continue;
		while((read_number = read(source_fd, buff, BUFSIZ)) > 0)
			if(write(object_fd, buff, read_number) < read_number)
				fatal("write");
		}
}

void
fatal(char *error_name)
{
	perror(error_name);
	exit(1);
}
