#include <stdio.h>

#define  ON		1
#define  OFF		0

#define  C_OPTION	1
#define  L_OPTION	2
#define  W_OPTION	3
#define  TOTAL		4

extern	int optind;

main(int argc, char *argv[])
{
	void	fatal(char *);
	FILE	*fp;
	int	c;
	int	option;
	int	OPTION;
	int	flag = ON;
	int	option_found = 0;
	int	count_character, count_word, count_line;
	int	total_character, total_word, total_line;


	if(argc < 2)
		{
		puts("usage : a.out [-clw] file");
		exit(0);
		}

	count_character = count_word = count_line = 0;
	total_character = total_word = total_line = 0;
	while((option = getopt(argc, argv, "clw")) != EOF)
		{
		switch(option)
			{
			case	'c' : OPTION = C_OPTION;
				option_found = ON;
				break;
			case	'l' : OPTION = L_OPTION;
				option_found = ON;
				break;
			case	'w' : OPTION = W_OPTION;
				option_found = ON;
				break;
			}
		}

	if(option_found == OFF)
		OPTION = TOTAL;

	argv+=optind;

	do	{
	if(*argv)
		{
		if((fp = fopen(*argv, "r")) == NULL)
			fatal("fopen");
		while((c = getc(fp)) != EOF)
			{
			count_character++;
			if(c == ' ' || c == '\n' || c == '\t')
				flag = ON;
			else	{
				if(flag == ON)
				count_word++;
				flag = OFF;
				}
			if(c == '\n')
				count_line++;
			}
		}

	switch(OPTION)
		{
		case	L_OPTION : printf("%7d", count_line);
			break;
		case	W_OPTION : printf("%7d", count_word);
			break;
		case	C_OPTION : printf("%7d", count_character);
			break;
		case	TOTAL : printf("%7d%7d%7d",
				count_line, count_word, count_character);
		}
	
	total_character += count_character;
	total_word += count_word;
	total_line += count_line;

	count_character = count_word = count_line = 0;
	printf(" %s\n", *argv);

	} while(*++argv);

	if(argc > 3 || (OPTION == TOTAL && argc == 3))
	{
	switch(OPTION)
		{
		case	L_OPTION : printf("%7d", total_line);
			break;
		case	W_OPTION : printf("%7d", total_word);
			break;
		case	C_OPTION : printf("%7d", total_character);
			break;
		case	TOTAL : printf("%7d%7d%7d",
				total_line, total_word, total_character);
		}

	printf(" total");

	}

}

void
fatal(char *error_name)
{
	perror(error_name);
	exit(0);
}
