#include <stdio.h>
#include <dirent.h>
#include <sys/stat.h>

#define  LEFT_STAR 1
#define  MIDDLE_STAR 2
#define  RIGHT_STAR 3
#define  ATIME  0
#define  ON 1
#define  OFF 0

time_t	now;
int	option = ATIME;
int	extention = 0;

main(int argc, char *argv[])
{
	void	check_match(DIR  *, char *, char *, char *);
	void	fatal(char *);
	char	path_name[BUFSIZ];
	char	object[BUFSIZ];
	char	user_time[10];
	struct	stat source_stat;
	DIR	*dir;
	int	count;


	if(argc < 3)
		{
		puts(" : % a.out directory_name pattern");
		exit(0);
		}

	time(&now);
	strcpy(object, argv[argc - 1]);
	strcpy(user_time, argv[argc - 2]);

	if(strchr(object, '*'))
		{
		extention = LEFT_STAR;
		strcpy(object, (char *)strrchr(object, '*')+1);
		}

	*argv++;
	for(count = 0;count < argc - 3;count++, *argv++)
	{
	if(stat(*argv, &source_stat) < 0)
		break;
	
	if(!S_ISDIR(source_stat.st_mode & S_IFMT))
		{
		printf("%s is not directory\n", *argv);
		exit(0);
		}

	if((dir = opendir(*argv)) == NULL)
		fatal("opendir");
	strcpy(path_name, *argv);
	check_match(dir, object, path_name, user_time);
	} /* for */
}

void
check_match(DIR *dir, char *pattern, char *path_name, char *user_time)
{
	void	fatal(char *);
	struct	dirent	*directory;
	struct	stat	file_stat;
	char	path_name_buff[BUFSIZ];
	int	source_size, pattern_size;
	int	gab;
	int	current, old;
	int	pattern_found = OFF;


	while(directory = readdir(dir))
	{
	if(!strncmp(directory->d_name, ".", 1))
		continue;
	if(directory->d_ino == 0)
		continue;

	sprintf(path_name_buff, "%s/%s", path_name, directory->d_name);
	if(stat(path_name_buff, &file_stat) < 0)
		fatal("stat");

	if(S_ISDIR(file_stat.st_mode & S_IFMT))
		{
		DIR	*imsi_dir;

		if((imsi_dir = opendir(path_name_buff)) < 0)
			fatal("opendir");
		check_match(imsi_dir, pattern, path_name_buff, user_time);
		}

	switch(extention)
	{
	case	LEFT_STAR : 
		source_size = strlen(directory->d_name);
		pattern_size = strlen(pattern);

		gab = source_size - pattern_size;

		if(gab < 0) continue;

		if(!strcmp(directory->d_name + gab, pattern))
			{
			pattern_found = ON;
			break;
			}
		else	continue;
	case	MIDDLE_STAR : break;
	case	RIGHT_STAR  : break;
	}

	switch(option)
	{
	case	ATIME :
		current = now/86400;
		old = file_stat.st_atime/86400;

		if(strchr(user_time, '-'))
		{
		if((current - old) <= atoi(strchr(user_time, '-')+1))
			puts(path_name_buff);
			
		} else	if((current - old) == atoi(user_time) &&
			pattern_found == ON)
			printf("%s\n", path_name_buff);
		break;
	} /* switch */
	} /* while() */

	closedir(dir);
}

void
fatal(char *error_name)
{
	perror(error_name);
	exit(1);
}
