#include <stdio.h>
#include <sys/stat.h>

#define  ON		1
#define  OFF		0

#define  FAIL		0
#define  FOUND		1

#define  C_OPTION	1
#define  I_OPTION	2
#define  L_OPTION	3
#define  N_OPTION	4
#define  NO_OPTION	5

void	fatal(char *);

main(int argc, char *argv[])
{
	void	find_string(char **, char *, int);
	int	option;
	int	flag_found = OFF;
	int	FLAG = 0;
	int	count = 0;
	char	*pattern;
	char	imsi_pattern[50];

	if(argc < 3)
		{
		puts(" : a.out -[ciln] pattern file_name");
		exit(0);
		}

	while((option = getopt(argc, argv, "ciln")) != EOF)
		{
		if(option == 'c')
			{
			FLAG = C_OPTION;
			flag_found = ON;
			}
		else	if(option == 'i')	
			{
			FLAG = I_OPTION;
			flag_found = ON;
			}
		else	if(option == 'l')
			{
			FLAG = L_OPTION;
			flag_found = ON;
			}
		else	if(option == 'n')
			{
			FLAG = N_OPTION;
			flag_found = ON;
			}
		}

	if(flag_found == ON)
		pattern = *(argv + 2);
	else	{
		FLAG = NO_OPTION;
		pattern = *(argv + 1);
		}
	if(FLAG == I_OPTION)
		{
		while(*pattern)
			{
			if(isalpha(*pattern))
				imsi_pattern[count] = toupper(*pattern);
			else	imsi_pattern[count] = *pattern;
			*pattern++;
			count++;
			}
		imsi_pattern[count] = '\0';
		}
	else	strcpy(imsi_pattern, pattern);



	find_string(argv, imsi_pattern , FLAG);
}

void
find_string(char *file[], char *pattern, int FLAG)
{
	int	check_string(char *, char *, int);
	FILE	*fp;
	char	input_string[200];
	int	c, i;
	int	count = 0;
	int	result = FAIL;
	int	count_found = 0;
	int	EXEC_FLAG = OFF;
	int	line_number;
	struct	stat file_stat;


	if(FLAG == NO_OPTION)
		file += 2;
	else	file += 3;

	do	
	{
	if(*file)
	{
	line_number = 0;
	if(stat(*file, &file_stat) < 0)
		{
		puts(" : a.out -[ciln] pattern file_name");
		exit(0);
		}
	if(S_ISDIR(file_stat.st_mode & S_IFMT))
		{
		printf("'%s' is a directory\n", *file);
		continue;
		}
	for(i = 0;i < 3;i++)
		if(file_stat.st_mode & (S_IEXEC >> (i * 3)))
			EXEC_FLAG = ON;
	if((fp = fopen(*file, "r")) == NULL)
		fatal("fopen");
	while((c = getc(fp)) != EOF)
		{
		input_string[count++] = c;
		if(c == '\n' || count == 199)
			{
			input_string[count] = '\0';		
			if(c == '\n')
				line_number++;
			count = 0;
			result =
				check_string(input_string, pattern, FLAG);
			if(result == FOUND)
			{
			result = FAIL;
			switch(FLAG)
				{
				case	NO_OPTION :
				case	I_OPTION :
					if(EXEC_FLAG == ON)
						{
						printf("Binary file %s "
						"matches\n", *file);
						goto EXIT;
						}
					printf("%s: %s", *file, input_string);
					break;
				case	C_OPTION :
					count_found++;
					break;
				case	L_OPTION :
					printf("%s\n", *file);
					goto EXIT;
				case	N_OPTION :
					if(EXEC_FLAG == ON)
						{
						printf("Binary file %s "
						"matches\n", *file);
						goto EXIT;
						}
					printf("%s:%d %s",
					*file, line_number, input_string);
					break;
				}
			continue;
			} /* if(resutl == FOUND) */
			} /* if(c == '\n') */

		}

	if(FLAG == C_OPTION)
		{
		printf("%s:%d\n", *file, count_found);
		count_found = 0;
		}

EXIT :
	fclose(fp);
	EXEC_FLAG = OFF;
		
	} /* if(*file) */
	} while(*file++);
	
}

int
check_string(char *input_string, char *pattern, int FLAG)
{
	char	imsi_input_string[200];
	int	count = 0;


	if(	FLAG == NO_OPTION || 
		FLAG == C_OPTION || 
		FLAG == L_OPTION ||
		FLAG == N_OPTION)
		if(strstr(input_string, pattern))
			return FOUND;
	if(FLAG == I_OPTION)
		{
		while(*input_string)
			{
			if(isalpha(*input_string))
				imsi_input_string[count] = toupper(*input_string);
			else	imsi_input_string[count] = *input_string;
			*input_string++;
			count++;
			}
		imsi_input_string[count] = '\0';
		count = 0;

		if(strstr(imsi_input_string, pattern))
			return FOUND;
		}
}

void
fatal(char *error_name)
{
	perror(error_name);
	exit(1);
}
